/// A token that can be used to retrieve the next page of results. This token is intentionally a string to
/// allow paging based on a variety of different criteria.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    Default
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct PageToken(pub String);
impl std::fmt::Display for PageToken {
    fn fmt(&self, fmt: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        std::fmt::Display::fmt(&self.0, fmt)
    }
}
impl conjure_object::Plain for PageToken {
    fn fmt(&self, fmt: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        conjure_object::Plain::fmt(&self.0, fmt)
    }
}
impl conjure_object::FromPlain for PageToken {
    type Err = <String as conjure_object::FromPlain>::Err;
    #[inline]
    fn from_plain(s: &str) -> Result<PageToken, Self::Err> {
        conjure_object::FromPlain::from_plain(s).map(PageToken)
    }
}
impl std::convert::From<String> for PageToken {
    #[inline]
    fn from(v: String) -> Self {
        PageToken(std::convert::From::from(v))
    }
}
impl std::ops::Deref for PageToken {
    type Target = String;
    #[inline]
    fn deref(&self) -> &String {
        &self.0
    }
}
impl std::ops::DerefMut for PageToken {
    #[inline]
    fn deref_mut(&mut self) -> &mut String {
        &mut self.0
    }
}
impl std::convert::AsRef<String> for PageToken {
    #[inline]
    fn as_ref(&self) -> &String {
        &self.0
    }
}
